import java.io.*;


public class UTF8Fix{
	
	public static void main(String[] args){
		
		if(args.length < 2 || args.length > 2){
			System.err.println("USAGE: java UTF8Fix [input] [output]");
			return;
		}
		ByteFixer byte_fixer = new ByteFixer(args[0]);
		File fout = new File(args[1]);
		BufferedOutputStream writer = null;
		
		try {
			writer = new BufferedOutputStream(new FileOutputStream(fout));
		} catch (FileNotFoundException e) {
			System.err.println("Problem opening writer, file not found");
			System.err.println("USAGE: java UTF8Fix [input] [output]");
			return;
		}
				
		byte[] character;
		int count = 0;
		String dots = "";
		while(true){
			character = byte_fixer.getNextCharacter();
			if(character==null)
				break;
			
			try {
				writer.write(character);
				count++;
			} catch (IOException e) {
				e.printStackTrace();
			}
			
			if(count%1000000==0){
				dots+= ".";
				if(dots.length() > 20){
					dots = "";
					System.out.println();
				}
				System.out.print("\r" + dots);
				System.out.flush();
			}
		}
		try {
			byte_fixer.close();
			writer.close();
		} catch (IOException e) {
			System.err.println("Unable to close reader/writer");
		}		
	}
}
